{----------------- TCONFIGTREEVIEW ------------------}

CONSTRUCTOR TConfigTreeView.NewConfigFile;

BEGIN
 Inherited NewConfigFile;
 QuoteSet:=[' ','?','!',#39];
 KeywordIndent  :=15;
 IniIndent      :=15;
 ParamIndent    :=5;
 KeySepPref:='=';
 HoldSectionComment:=FALSE;
END;

FUNCTION TConfigTreeView.GetNextParam(VAR Handle:PParamData):ParamType;

VAR Pa : ParamType;

BEGIN
 IF Handle<>NIL THEN
  BEGIN
   Pa:=Handle^.Param;
   Handle:=Handle^.NextParam
  END
 ELSE
  FillChar(Pa,SIZEOF(ParamType),#0);
 GetNextParam:=Pa;
END;

PROCEDURE TConfigTreeView.WriteValue(Handle:PLineData;Level:LONGINT);

VAR S : String;
    I : LONGINT;
    P : PParamData;
    PD : ParamType;

PROCEDURE RollOutParam;

BEGIN
   P:=Handle^.ParamData;
   WHILE P<>NIL DO
    BEGIN
     PD:=GetNextParam(P);
     IF NOT((PD.ValueType=0) AND (PD.Value='')) THEN
        CASE PD.ValueType OF
         0 : Write(FText,PD.Value);
         1 : Write(FText,PD.Value);
        END;
     IF P<>NIL THEN
      Write(FText,' ');
    END;
END;


BEGIN
 IF Handle^.KeyNo<>-1 THEN
  BEGIN
   i:=CallRoutineToIndex(Handle^.KeyNo);
   Write(FText,keyw[I].Name, ' ');
   I:=KeywordIndent-Length(keyw[I].Name);
   IF (I>0) THEN
    Write(FText,' ':I);
   RollOutParam;
  END
 ELSE
  BEGIN
   Write(FText,Handle^.ValueName);
   I:=IniIndent-Length(Handle^.ValueName);
   IF (I>0)  THEN
    BEGIN
     Write(FText,' ':I);
     I:=0;
    END;
   IF IsIni THEN
    BEGIN
     Write (FText,KeySepPref);
     I:=I+ParamIndent;
     IF (i>0) THEN
      Write(FText,' ':I);
     END;
    RollOutParam;
  END;
 Writeln(FText);
END;

PROCEDURE TConfigTreeView.WriteSection(Section : PSection);

VAR A :LONGINT;

BEGIN
 IF Section^.SectionName<>'ROOTSECTION' THEN
  BEGIN
   FOR A:=1 TO Section^.Level DO
    Write(FText,'[');
   Write(FText,Section^.SectionName);
   FOR A:=1 TO Section^.Level DO
    Write(FText,']');
   Writeln(FText);
  END;
END;

PROCEDURE TConfigTreeView.BeforeExitFile;

BEGIN
END;


PROCEDURE TConfigTreeView.WriteComment(Comments : PChar);

VAR I : LONGINT;

BEGIN
 IF Comments<>NIL THEN
  BEGIN
 I:=0;
 WHILE Comments[I]<>#0 DO
  BEGIN
   IF Comments[I]<>#10 THEN
    Write(FText,Comments[I])
   ELSE
    BEGIN
     Writeln(FText);
    END;
   INC(I);
  END;
 END;
END;

PROCEDURE TConfigTreeView.WriteTree(FileName:String);

VAR CommentChar : Char;                 {First CommentChar in Comment set}

PROCEDURE ParseParam(XParam:PParamData;Nr:LONGINT);

VAR A : LONGINT;

BEGIN
 IF Nr<>0 THEN
  Write(FText,' , ');
 INC(Nr);
 A:=CharPosSet(XParam^.Param.Value,QuoteSet);
 IF A<>0 THEN
  Write(FText,'"');
 Write(FText,XParam^.Param.Value);
 IF A<>0 THEN
  Write(FText,'"');
 if XParam^.NextParam<>NIL THEN
  ParseParam(XParam^.Nextparam,Nr);
END;

PROCEDURE ParseLine(XLine:PLineData;Level:LONGINT);

VAR i :longint;

BEGIN
 WriteComment(XLine^.Comments);
 WriteValue(XLine,Level);
 IF XLine^.NextLineData<>NIL THEN
  ParseLine(XLine^.NextLineData,Level);
END;


PROCEDURE ParseSection(Section:PSection);

VAR A : LONGINT;

BEGIN
 IF NOT HoldSectionComment THEN
  WriteComment(Section^.Comments);
 WriteSection(Section);
 IF Section^.LineData<>NIL THEN
  ParseLine(Section^.LineData,Section^.Level);
 IF Section^.SubSection<>NIL THEN
  ParseSection(Section^.SubSection);
 IF Section^.NextSection<>NIL THEN
  ParseSection(Section^.NextSection);
END;

VAR I :LONGINT;

BEGIN
 I:=32;
 WHILE (NOT (CHR(I) IN CommentSet)) AND (I<256) DO
  INC(I);
 IF I=256 THEN
  CommentChar:=';'
 ELSE
  CommentChar:=CHR(I);
 Assign(FText,Filename);
 Rewrite(FText);
 ParseSection(RootSection);
 BeforeExitFile;
 WriteComment(BackComment);
 Close(FText);
END;
