
{---------------------------------------------------------------------
                          Asm versions of some Ansistrings procedures}

{ Pos for one char only. Faster than an ordinary Pos}
FUNCTION CharPos(CONST S :AnsiString;C:Char):LONGINT; ASSEMBLER;

ASM // Pas strings allow repne scasb, probably very fast

                      movl  S ,%edi       // Load String
                      movl  -8(%edi),%ecx      // Load Length
                      cld
                      inc  %ecx
                      mov   %ecx,%ebx
                      movb  C ,%al
                      repne
                       scasb
                      jne  .LAcharposnotfound
                      sub  %ecx,%ebx
                      mov  %ebx,%eax
                      jmp .LAcharposready
.LAcharposnotfound:    xor %eax,%eax
.LAcharposready:
END ['EAX','EBX','ECX','EDI'];

{ Like CharPos but starts searching on character number Count (zero based),
    returnvalue is zero based and absolute (to beginning of string)}
FUNCTION NextCharPos(CONST S:AnsiString;C:Char;Count:LONGINT):LONGINT; ASSEMBLER;

    ASM // Pas strings allow repne scasb, probably very fast
                      movl S    ,%edi       // Load String
                      movl Count,%edx
                      cld
                      movl -8(%edi),%ecx
                      cmpl %ecx,%edx
                      ja .LNAcharposnotfound
                      addl %edx,%edi              // Start on higher address
                      decl  %edi
                      subl %edx,%ecx
                      mov   %ecx,%ebx
                      inc  %ecx
                      movb  C   ,%al
                      repne
                       scasb
                      jne  .LNAcharposnotfound
                      sub  %ecx,%ebx
                      mov  %ebx,%eax
                      addl %edx,%eax
                      jmp .LNAcharposready
.LNAcharposnotfound:  xor %eax,%eax
.LNAcharposready:
END ['EAX','EBX','ECX','EDX','EDI'];

FUNCTION CharPosSet(CONST S : AnsiString;CONST CSet:CHARSET):LONGINT; ASSEMBLER;

    ASM
                      movl  S,%esi       // Load String
                      movl -8(%esi),%ecx
                      mov   %ecx,%edi          // Keep backup.
                      movl  CSet,%ebx
.LACharPosSetLoop:    lodsb
                      movl  %eax,%edx
                      andl  $0xf8,%edx
                      shrl  $3,%edx
                      andl  $7,%eax
                      dec   %ecx
                      js    .LACharPosSetEOS
                      btl   %eax,(%ebx,%edx)
                      jnc   .LACharPosSetLoop
                      sub   %ecx,%edi
                      mov   %edi,%eax
                      jmp   .LACharPosSetEnd
.LACharPosSetEOS:     xor %eax,%eax
.LACharPosSetEnd:
END ['EAX','EBX','ECX','EDX','ESI','EDI'];


FUNCTION RCharPos(CONST S :AnsiString;C:Char):LONGINT; ASSEMBLER;

    ASM
                      movl S,%edi       // Load String
                      movl -8(%edi),%eax
                      add  %eax,%edi
                      decl %edi               // 0-base length.
                      mov  %eax,%ecx
                      inc  %ecx
                      movb C,%al
                      std
                      repne
                       scasb
                      jne  .LArcharposnotfound
                      cld
                      mov %ecx,%eax
                      jmp  .LArcharposEnd
.LArcharposnotfound:  xor %eax,%eax
.LArcharposEnd:
END ['EAX','ECX','EDI'];

FUNCTION NextRCharPos(CONST S: AnsiString;C:Char;Count:LONGINT):LONGINT; ASSEMBLER;

    ASM
                          movl   S,%edi       // Load String
                          movl  -8(%edi),%eax
                          movl  Count,%ecx
                          cmp  %eax,%ecx            // Count>Length
                          ja   .Lnrcharposnotfound
                          add  %ecx,%edi
                          decl %edi                 // AnsiString, no length byte
                          inc  %ecx
                          movb C,%al
                          std
                          repne
                           scasb
                          jne  .Lnrcharposnotfound
                          cld
                          mov %ecx,%eax
                          jmp .LNrcharposnotend
    .Lnrcharposnotfound: xor %eax,%eax
    .LNrcharposnotend:
END ['EAX','ECX','EDI'];
